#include "c:/jeux/emulateur/exl/tasm/H/7020.equ"
ENDVDP .equ $FFFF
IMAGE  .equ $0A00
CLS		 .equ $F022

	.org $C300

go_on
	movd %message1,TEMP1
	call @print_mess
	
	call @wait

	movd %message2,TEMP1
	call @print_mess
	
  call @ld_header

	call @check_file
	cmp %0,A
	jeq load_data
	movd %message3,TEMP1
	call @print_mess	
	call @wait
	br @go_on
	
load_data
	movd %ENDVDP,TEMP9	
	lda @jif_length+1
	mov A,B
	lda @jif_length
	decd B
	sub B,TEMP9
	sbb A,TEMP9-1
	movd TEMP9,B
	sta @start_data
	mov B,A
	sta @start_data+1
	call @ld_data

display_data	
	lda @start_data+1
	mov A,B
	lda @start_data
	movd B,TEMP2
	movd %IMAGE,TEMP1
	call @display
	br @go_on
	rets

wait
	cmp %27,VALUE0
	jne wait
	rets

print_mess
	push TEMP1
	push TEMP1-1
	movd %clear_mess,TEMP1
	mov %1,A
	sta @$C04F
	mov %24,A
	sta @$C04E
	call @$F01F		
	mov %1,A
	sta @$C04F
	mov %24,A
	sta @$C04E
	pop TEMP1-1
	pop TEMP1
	call @$F01F	
	rets

decode_line
	push B
	push TEMP2
	push TEMP2-1
	mov A,TEMP3
	clr TEMP3-1
	lda @data_decode_line
	jz debut_decode
	push A
	btjo %$80,A,continue_decode
	movd TEMP2, B
	movd TEMP1,TEMP2
	movd B,TEMP1
	trap 10
	pop A
	jmp make_decode
continue_decode
	trap 10
	pop A
	jmp nocomp
debut_decode
	trap 10	
next_code
	lvdp
	inc TEMP3-1
make_decode
	btjo %$80,A,nocomp
	mov A,B
	and %$1,B
	clrc
	rrc A
	inc A
	mov A,TEMP2
rept_color	
	lda @blackAndWhite[B]
	wvdp(A)
	lda @blackAndWhite[B]
	wvdp(A)
	wvdp(%0)
	dec TEMP3
	jz fin_decode_line1
	djnz TEMP2,rept_color
	jmp next_code	   
nocomp
	and %$7F,A
	inc A
	mov A,TEMP2
rept_motif
	lvdp
	wvdp(A)
	lvdp
	wvdp(A)
	wvdp(%0)
	add %2,TEMP3-1
	dec TEMP3
	jz fin_decode_line2
	djnz TEMP2,rept_motif
	jmp next_code
fin_decode_line1
	dec TEMP2
	jz fin_decode_line
	dec TEMP2
	rl TEMP2
	or B,TEMP2
	jmp fin_decode_line
fin_decode_line2
	dec TEMP2
	jz fin_decode_line
	dec TEMP2
	or %$80,TEMP2
fin_decode_line
	mov TEMP2,A
	sta @data_decode_line
	pop TEMP2-1
	pop TEMP2
	pop B
	add TEMP3-1,TEMP2
	adc %0,TEMP2-1
	rets
data_decode_line
	.byte 
blackAndWhite
	.byte $00,$FF
			
display
	movd TEMP1,TEMP4
	lda @jif_heigth
	mov %250,B
	sub A,B
	clrc
	rrc B
	mpy %122,B
	add B,TEMP4
	adc A,TEMP4-1
	lda @jif_width
	mov %40,B
	sub A,B
	clrc
	rrc B
	mpy %3,B
	add B,TEMP4
	adc %0,TEMP4-1
	lda @jif_heigth
	mov A,B
next_line
	movd TEMP4,TEMP1
	lda @jif_width
	call @decode_line
	add %122,TEMP4
	adc %0,TEMP4-1
	djnz B,next_line
	rets

ld_header
	mov %INRAMU,TEMP10
	or %8,TEMP10
	movd %jif_header,TEMP8	
	movd %jif_header,TEMP9
	add %$09,TEMP9
	adc %0,TEMP9
	trap 14
	rets

ld_data		
	mov %INVDPU,TEMP10
	or %8,TEMP10
	mov %$7A,TEMP10-1
	movd TEMP9,TEMP8
	movd %ENDVDP,TEMP9
	trap 14
	rets

check_file
	clr B
next_check
	lda @jif_check(B)
	push B
	push A
	lda @jif_check+1(B)
	pop B
	cmpa @jif_header(B)
	jeq ok_check
	mov %1,A
	pop B
	rets
ok_check
	pop B
	add %2,B
	cmp %10,B
	jne next_check
	clr A
	rets

clear_mess
	.fill 35,$20
	.byte 0                                        
message1
	.byte "Press <ECHAP> for loading picture.",0
message2
	.byte "Loading picture...",0
message3
	.byte "File Error: <ECHAP> to continue...",0
jif_check
	.byte 0,'J',1,'I',2,'F',3,$01,8,$0					
start_data
	.byte 0,0
jif_header
	.byte 0,0,0,0
jif_width
	.byte 0
jif_heigth
	.byte 0
jif_length
	.byte 0,0
	.byte 0,0

	.end